GASNET_PREFIX="/opt/mvapich2-x/gnu"
GASNET_LD_OVERRIDE="gcc"
GASNET_LDFLAGS_OVERRIDE="--param max-inline-insns-single=35000 --param inline-unit-growth=10000 --param large-function-growth=200000 -Winline -Wl,-z,relro"
GASNET_LD_OVERRIDE="${GASNET_PREFIX}/bin/mpicc"
GASNET_LDFLAGS_OVERRIDE="--param max-inline-insns-single=35000 --param inline-unit-growth=10000 --param large-function-growth=200000 -Winline -Wl,-z,relro"
MPI_COMPAT_LIBS=""
SSH_LIBS=""
CONDUIT_INCLUDES="-DGASNET_CONDUIT_MVAPICH2X -I${GASNET_PREFIX}/include"
CONDUIT_LIBDIRS="-L${GASNET_PREFIX}/lib64"
CONDUIT_LIBS="-Wl,-rpath-link,${GASNET_PREFIX}/lib64 -lmpich ${MPI_COMPAT_LIBS} ${SSH_LIBS}"
GASNET_INCLUDES="-I${GASNET_PREFIX}/include -I${GASNET_PREFIX}/include/mvapich2x-conduit ${CONDUIT_INCLUDES} ${CONDUIT_INCLUDES_SEQ}"
GASNET_LIBDIRS="-L${GASNET_PREFIX}/lib64 ${CONDUIT_LIBDIRS} ${CONDUIT_LIBDIRS_SEQ}"
GASNET_CC="gcc"
GASNET_OPT_CFLAGS="-O3 --param max-inline-insns-single=35000 --param inline-unit-growth=10000 --param large-function-growth=200000 -Winline ${CONDUIT_OPT_CFLAGS} ${CONDUIT_OPT_CFLAGS_SEQ}"
GASNET_MISC_CFLAGS="${CONDUIT_MISC_CFLAGS} ${CONDUIT_MISC_CFLAGS_SEQ}"
GASNET_MISC_CPPFLAGS="${CONDUIT_MISC_CPPFLAGS} ${CONDUIT_MISC_CPPFLAGS_SEQ}"
GASNET_CXX="/usr/lib64/ccache/g++"
GASNET_OPT_CXXFLAGS="-O2 ${CONDUIT_OPT_CFLAGS} ${CONDUIT_OPT_CFLAGS_SEQ}"
GASNET_MISC_CXXFLAGS="${CONDUIT_MISC_CFLAGS} ${CONDUIT_MISC_CFLAGS_SEQ}"
GASNET_MISC_CXXCPPFLAGS="${CONDUIT_MISC_CPPFLAGS} ${CONDUIT_MISC_CPPFLAGS_SEQ}"
GASNET_EXTRADEFINES_SEQ=""
GASNET_EXTRADEFINES_PAR="-D_REENTRANT -D_GNU_SOURCE"
GASNET_EXTRADEFINES_PARSYNC="-D_REENTRANT -D_GNU_SOURCE"
GASNET_DEFINES="-DGASNET_SEQ ${GASNET_EXTRADEFINES_SEQ} ${CONDUIT_DEFINES} ${CONDUIT_DEFINES_SEQ}"
GASNET_CFLAGS="${GASNET_OPT_CFLAGS} ${GASNET_MISC_CFLAGS} ${MANUAL_CFLAGS}"
GASNET_CPPFLAGS="${GASNET_MISC_CPPFLAGS} ${GASNET_DEFINES} ${GASNET_INCLUDES}"
GASNET_CXXFLAGS="${GASNET_OPT_CXXFLAGS} ${GASNET_MISC_CXXFLAGS} ${MANUAL_CXXFLAGS}"
GASNET_CXXCPPFLAGS="${GASNET_MISC_CXXCPPFLAGS} ${GASNET_DEFINES} ${GASNET_INCLUDES}"
GASNET_LD="${GASNET_LD_OVERRIDE}"
GASNET_LDFLAGS="${GASNET_LDFLAGS_OVERRIDE} ${CONDUIT_LDFLAGS} ${CONDUIT_LDFLAGS_SEQ} ${MANUAL_LDFLAGS}"
GASNET_EXTRALIBS_SEQ=""
GASNET_EXTRALIBS_PAR="-lpthread"
GASNET_EXTRALIBS_PARSYNC="-lpthread"
GASNET_LIBS="${GASNET_LIBDIRS} -lgasnet-mvapich2x-seq ${CONDUIT_LIBS} ${CONDUIT_LIBS_SEQ} ${GASNET_EXTRALIBS_SEQ} -lrt -L/usr/lib/gcc/x86_64-redhat-linux/4.8.5 -lgcc -lm ${MANUAL_LIBS}"
UPCXX_CXXFLAGS="${GASNET_CPPFLAGS} -I/opt/mvapich2-x/gnu/include -Wno-literal-suffix -DGASNETT_USE_GCC_ATTRIBUTE_MAYALIAS=1 -DGASNET_ALLOW_OPTIMIZED_DEBUG -std=c++11"
UPCXX_LDLIBS="-L/opt/mvapich2-x/gnu/lib64 /opt/mvapich2-x/gnu/lib64/libupcxx.a ${GASNET_LIBS}"
UPCXX_LDFLAGS="${GASNET_LDFLAGS}"
UPCXX_DIR="/opt/mvapich2-x/gnu"
export UPCXX_LDLIBS
export UPCXX_LDFLAGS
export UPCXX_CXXFLAGS
export PATH=$PATH:$UPCXX_DIR/bin
